1#! /bin/sh
2#
3# Update a local Subversion, Git or Mercurial tree from the GCC
4# repository, with an emphasis on treating generated files correctly, so
5# that autoconf, gperf et al are not required for the ``end'' user.
6#
7# (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009,
8# 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
9# Originally by Gerald Pfeifer <gerald@pfeifer.com>, August 1998.
10#
11# This script is Free Software, and it can be copied, distributed and
12# modified as defined in the GNU General Public License.  A copy of
13# its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14#
15#
16# By default all command-line options are passed to `svn update` or `hg/git
17# pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18# reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19# are omitted.
20#
21# If the first parameter reads --patch, the second parameter is considered
22# a patch file.
23#
24# If the first parameter is --touch, no svn operation will be performed,
25# only generated files that appear to be out of date in the local tree
26# will be touched.
27#
28# If the first parameter is --list, a list of the generated files and
29# their dependencies will be printed; --help prints this message.
30#
31# If the first parameter is --silent, this script prints nothing other
32# than error messages; the second parameter is then interpreted as above.
33#
34# Examples:
35#
36# contrib/gcc_update -r 8712
37# contrib/gcc_update --patch some-patch
38# contrib/gcc_update --touch
39# contrib/gcc_update --list
40
41
42# Default options used when updating (none).
43UPDATE_OPTIONS=""
44
45# Set the locale to C to make this script work for users with foreign
46# locale like e.g. French UTF-8.
47LANG=C
48LC_ALL=C
49export LANG LC_ALL
50
51######## Anything below shouldn't be changed by regular users.
52
53# Arrange for the value of $0 to be available for functions
54self=$0
55
56# This function prints its arguments to standard output unless
57# "silent" is set.
58unset silent
59chat () {
60    if [ -z "$silent" ]; then
61        echo "$@"
62    fi
63}
64
65# This function prints a list of all generated files, along with their
66# dependencies.  Note that only one target is supported per line: the
67# colon is stripped from the output.
68files_and_dependencies () {
69    sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70# fixincludes
71fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73# intl library
74intl/plural.c: intl/plural.y
75intl/plural-config.h: intl/plural.y
76intl/configure: intl/configure.ac intl/aclocal.m4
77intl/config.h.in: intl/configure.ac intl/aclocal.m4
78# Now, proceed to gcc automatically generated files
79gcc/configure: gcc/configure.ac
80gcc/cstamp-h.in: gcc/configure.ac
81gcc/config.in: gcc/cstamp-h.in
82gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
83gcc/config/aarch64/aarch64-tune.md: gcc/config/aarch64/aarch64-cores.def gcc/config/aarch64/gentune.sh
84gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
85gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
86gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
87gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
88gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
89gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
90gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
91gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
92gcc/config/rs6000/fusion.md: gcc/config/rs6000/genfusion.pl
93gcc/config/tilegx/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
94gcc/config/tilepro/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
95# And then, language-specific files
96gcc/cp/cfns.h: gcc/cp/cfns.gperf
97# testsuite
98# Without this, _Pragma3.c can have a false negative.
99gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
100# Similarly, without this, you will see:
101# direct2s.c:35: warning: current file is older than direct2.c
102gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
103# lto-plugin
104lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
105lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
106# tools
107c++tools/configure: c++tools/configure.ac
108c++tools/config.h.in: c++tools/configure.ac
109# And libraries, at last
110libbanshee/configure: libbanshee/configure.ac
111libmudflap/configure: libmudflap/configure.ac
112libobjc/configure: libobjc/configure.ac
113zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
114zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
115zlib/configure: zlib/configure.ac zlib/aclocal.m4
116fastjar/aclocal.m4: fastjar/configure.ac
117fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
118fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
119boehm-gc/aclocal.m4: boehm-gc/configure.ac
120boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
121boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
122libada/configure: libada/configure.ac
123libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
124libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
125libffi/configure: libffi/configure.ac libffi/aclocal.m4
126libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
127libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
128libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
129libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
130libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
131libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
132libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
133libcody/configure: libcody/configure.ac libcody/config.m4
134libcpp/aclocal.m4: libcpp/configure.ac
135libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
136libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
137libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
138libgomp/Makefile.am: libgomp/plugin/Makefrag.am
139libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
140libgomp/testsuite/Makefile.in: libgomp/testsuite/Makefile.am libgomp/aclocal.m4
141libgomp/configure.ac: libgomp/plugin/configfrag.ac
142libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
143libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
144libhsail-rt/aclocal.m4: libhsail-rt/configure.ac
145libhsail-rt/Makefile.in: libhsail-rt/Makefile.am libhsail-rt/aclocal.m4
146libhsail-rt/configure: libhsail-rt/configure.ac libhsail-rt/aclocal.m4
147libhsail-rt/target-config.h.in: libhsail-rt/configure.ac libhsail-rt/aclocal.m4
148libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
149libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
150libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
151libitm/configure: libitm/configure.ac libitm/aclocal.m4
152libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
153libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
154libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
155libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
156libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
157libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
158libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
159libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
160libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
161libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
162libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
163libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
164libvtv/aclocal.m4: libvtv/configure.ac libvtv/acinclude.m4
165libvtv/Makefile.in: libvtv/Makefile.am libvtv/aclocal.m4
166libvtv/configure: libvtv/configure.ac libvtv/aclocal.m4
167liboffloadmic/aclocal.m4: liboffloadmic/configure.ac
168liboffloadmic/Makefile.in: liboffloadmic/Makefile.am
169liboffloadmic/configure: liboffloadmic/configure.ac
170liboffloadmic/plugin/aclocal.m4: liboffloadmic/plugin/configure.ac
171liboffloadmic/plugin/Makefile.in: liboffloadmic/plugin/Makefile.am
172liboffloadmic/plugin/configure: liboffloadmic/plugin/configure.ac
173libbacktrace/aclocal.m4: libbacktrace/configure.ac
174libbacktrace/Makefile.in: libbacktrace/Makefile.am libbacktrace/aclocal.m4
175libbacktrace/configure: libbacktrace/configure.ac libbacktrace/aclocal.m4
176libbacktrace/config.h.in: libbacktrace/configure.ac libbacktrace/aclocal.m4
177libphobos/Makefile.in: libphobos/Makefile.am libphobos/configure.ac libphobos/aclocal.m4
178libphobos/aclocal.m4: libphobos/configure.ac libphobos/acinclude.m4
179libphobos/config.h.in: libphobos/configure.ac libphobos/aclocal.m4
180libphobos/configure: libphobos/configure.ac libphobos/aclocal.m4
181libphobos/src/Makefile.in: libphobos/src/Makefile.am libphobos/aclocal.m4
182libphobos/testsuite/Makefile.in: libphobos/testsuite/Makefile.am libphobos/aclocal.m4
183# Top level
184Makefile.in: Makefile.tpl Makefile.def
185configure: configure.ac config/acx.m4
186EOF
187}
188
189
190# This function touches generated files such that the ``end'' user does
191# not have to rebuild them.
192touch_files () {
193    rm -f Makefile.$$
194    echo 'all: \' > Makefile.$$
195    files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
196    echo '; @true' >> Makefile.$$
197    files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
198    files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
199    echo ':' >> Makefile.$$
200    echo '	@for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
201    echo '	echo Touching $@...; \' >> Makefile.$$
202    chat '	echo Touching $@... 1>&2; \' >> Makefile.$$
203    echo '	touch $@' >> Makefile.$$
204    files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
205
206    # We would have to explicitly shut off the "Entering... Leaving..."
207    # messages through "--no-print-directory" to handle the case when
208    # we were called from a recursive invocation (i.e. "$(MAKE)" in a
209    # Makefile, not just make).  Passing only "-s" doesn't help then,
210    # because make has helpfully added "-w" to MAKEFLAGS automatically.
211    # Unfortunately we do not require GNU make other than for building
212    # and testing, so let's just grep known text explicitly echoed by
213    # the rule.
214    while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
215      sleep 1
216    done 2>&1
217    rm -f Makefile.$$
218}
219
220
221# Whenever we update the tree or install a patch, we may be modifying
222# this script.  By re-execing it, we ensure that the appropriate
223# dependencies and rules will be used.
224touch_files_reexec () {
225    chat "Adjusting file timestamps"
226    exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
227}
228
229# This functions applies a patch to an existing tree.
230apply_patch () {
231    if [ -f "$1" ]; then
232	echo "Applying patch file $1"
233	case $1 in
234	*gz)
235	    gzip -d -c "$1" | patch -p1 ;;
236	*bz2)
237	    bzip2 -d -c "$1" | patch -p1 ;;
238	*)
239	    patch -p1 < "$1";;
240	esac
241    fi
242    touch_files_reexec
243}
244
245# Check whether this indeed looks like a local tree.
246if [ ! -f gcc/version.c ]; then
247    echo "This does not seem to be a GCC tree!"
248    exit
249fi
250
251case "$1" in
252--silent)
253    silent=t
254    shift
255    ;;
256esac
257
258case "$1" in
259# First of all, check whether we are going to process a patch.
260--patch)
261    if test "$#" != 2; then
262        echo "$1" expects only one argument >&2
263	exit 1
264    fi
265    apply_patch "${2}"
266    exit $?
267    ;;
268
269--touch)
270    if test "$#" != 1; then
271        echo "$1" does not expect any argument >&2
272	exit 1
273    fi
274    touch_files
275    exit $?
276    ;;
277
278--list)
279    if test "$#" != 1; then
280        echo "$1" does not expect any argument >&2
281	exit 1
282    fi
283    files_and_dependencies | sed 's/ /: /'
284    exit $?
285    ;;
286
287--help)
288    sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
289\
290
291p
292}' \
293	-e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
294    exit $?
295    ;;
296
297esac
298
299# Check for known version control systems.
300if [ -d .git ] || [ -f .git ]; then
301    GCC_GIT=${GCC_GIT-${GIT-git}}
302    vcs_type="git"
303elif [ -d .hg ]; then
304    GCC_HG=${GCC_HG-${HG-hg}}
305    vcs_type="hg"
306elif [ -d .svn ]; then
307    GCC_SVN=${GCC_SVN-${SVN-svn}}
308    vcs_type="svn"
309else
310    echo "This does not seem to be a GCC GIT/HG/SVN tree!"
311    exit
312fi
313
314# Check command-line options
315if [ x"${1}"x = x"--nostdflags"x ]; then
316    shift
317else
318    set -- $UPDATE_OPTIONS ${1+"$@"}
319fi
320
321case $vcs_type in
322    git)
323	chat "Updating GIT tree"
324
325	$GCC_GIT diff --quiet --exit-code HEAD
326	if [ $? -ne 0 ]; then
327            echo "Attempting to update a dirty git tree!" >&2
328            echo "Commit or stash your changes first and retry." >&2
329            exit 1
330	fi
331
332	$GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
333	if [ $? -ne 0 ]; then
334            (touch_files_reexec)
335            echo "git pull of full tree failed." >&2
336            exit 1
337	fi
338
339	revision=`$GCC_GIT log -n1 --pretty=tformat:%p:%t:%H`
340	branch=`$GCC_GIT name-rev --name-only HEAD || :`
341	;;
342
343    hg)
344	chat "Updating HG tree"
345
346	# Add -q so untracked files aren't listed.
347	if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
348            echo "Attempting to update a dirty hg tree!" >&2
349            echo "Commit or revert your changes first and retry." >&2
350            exit 1
351	fi
352
353	# Check for mq extension.  mq patches must be popped so tip has
354	# been converted from the SVN tree.
355	if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
356	    # FIXME: Perhaps pop queue instead?  We could do that since we
357	    # know the tree is clean.
358	    echo "Attempting to update hg tree with mq patches applied!" >&2
359	    echo "Pop your patches first and retry." >&2
360	    exit 1
361	fi
362
363	# Update tree, but make sure to only pull the default branch.
364	# Otherwise all branches in the upstream repo are added, even if
365	# only a single one has been cloned.
366	$GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
367	if [ $? -ne 0 ]; then
368            (touch_files_reexec)
369            echo "hg pull of full tree failed." >&2
370            exit 1
371	fi
372
373	# Update tree.  Needs to be done separately from pull so
374	# gcc_update -rREV works.
375	$GCC_HG update ${silent+-q} ${1+"$@"}
376	if [ $? -ne 0 ]; then
377            (touch_files_reexec)
378            echo "hg update of full tree failed." >&2
379            exit 1
380	fi
381
382	# Extract SVN revision corresponding to parents, as stored by
383	# hg convert.  Before hg 1.4.3, there's no template keyword
384	# corresponding to the extra: tag, so need to use hg log --debug
385	# to extract the info.
386	parents=`$GCC_HG parents --template '{rev}'`
387	convert_revision=`$GCC_HG log --debug -r$parents | \
388	    sed -ne "/^extra:.*convert_revision=svn:/ {
389	        s%^[^/]*/%%
390		p
391	    }"`
392	revision=`echo $convert_revision | sed -e 's/.*@//'`
393	branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
394	;;
395
396    svn)
397	chat "Updating SVN tree"
398
399	$GCC_SVN ${silent+-q}  --non-interactive update ${1+"$@"}
400	if [ $? -ne 0 ]; then
401	    (touch_files_reexec)
402	    echo "SVN update of full tree failed." >&2
403	    exit 1
404	fi
405
406	revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
407	branch=`$GCC_SVN info | sed -ne "/^URL:/ {
408	    s,.*/trunk,trunk,
409	    s,.*/branches/,,
410	    s,.*/tags/,,
411	    p
412	}"`
413	;;
414esac
415
416rm -f LAST_UPDATED gcc/REVISION
417{
418    date
419    echo "`TZ=UTC date` (revision $revision)"
420} > LAST_UPDATED
421echo "[$branch revision $revision]" > gcc/REVISION
422
423touch_files_reexec
424